const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const email_templates = sequelize.define(
    'email_templates',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

subject: {
        type: DataTypes.TEXT,
      
      

      },

html_body: {
        type: DataTypes.TEXT,
      
      

      },

text_body: {
        type: DataTypes.TEXT,
      
      

      },

template_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"reminder",


"deal_update",


"lead_assigned",


"daily_digest",


"custom"

        ],

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  email_templates.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















    db.email_templates.hasMany(db.email_notifications, {
      as: 'email_notifications_template',
      foreignKey: {
          name: 'templateId',
      },
      constraints: false,
    });













//end loop



    db.email_templates.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.email_templates.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.email_templates.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.email_templates.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return email_templates;
};


